<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 05/30/2004 *
 * ===============                              Last change: 08/09/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : autopurge_functions.php                          *
 * -------------------------------------------------------------------- *
 * Short description : Special functions                                *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Spezielle Funktionen                             *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

function AUTOPURGE_ADD_POINTS($uid, $points) {
	// Check if he has locked points or not
	$result = SQL_QUERY_ESC("SELECT ref_payout FROM `{!_MYSQL_PREFIX!}_user_data` WHERE userid=%s LIMIT 1",
		array(bigintval($uid)), __FILE__, __LINE__);
	list($payout) = SQL_FETCHROW($result);
	SQL_FREERESULT($result);

	if (($payout > 0) && (!empty($payout))) {
		// Yes, he has.
		$target = "locked_points";
	} elseif ($payout == "0") {
		// No, he has not
		$target = "points";
	}

	// Add points...
	if (empty($payout)) {
		// ... to jackpot account
		ADD_JACKPOT($points);
		if (empty($jackpot)) $jackpot = 0;
		$jackpot += $points;
	} else {
		// .. to user's account
		SQL_QUERY_ESC("UPDATE `{!_MYSQL_PREFIX!}_user_points` SET %s=%s+%s WHERE userid=%s AND ref_depth=0 LIMIT 1",
			array($target, $target, $points, bigintval($uid)), __FILE__, __LINE__);

		// Update mediadata as well
		if ((GET_EXT_VERSION("mediadata") >= "0.0.4") && ($target == "points")) {
			// Update database
			MEDIA_UPDATE_ENTRY(array("total_points"), "add", $points);
		}

		// Send out mail to user
		$msg = LOAD_EMAIL_TEMPLATE("member_autopurge_points", TRANSLATE_COMMA($points), $uid);
		SEND_EMAIL($uid, AUTOPURGE_MEMBER_SUBJECT, $msg);
	}
}

//
?>
