<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 02/28/2009 *
 * ===============                              Last change: 02/28/2009 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : request-functions.php                            *
 * -------------------------------------------------------------------- *
 * Short description : Special functions for request handling           *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Spezialle Funktionen fuer die Anfragebehandlung  *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
} // END - if

// Wrapper for elements in $_GET
function REQUEST_GET ($element) {
	// By default no element is there
	$value = null;

	// Is the element cached or there?
	if (isset($GLOBALS['cache_array']['request_get'][$element])) {
		// Then use the cache
		$value = $GLOBALS['cache_array']['request_get'][$element];
	} elseif (REQUEST_ISSET_GET($element)) {
		// Then get it directly
		$value = SQL_ESCAPE($_GET[$element]);

		// Store it in cache
		$GLOBALS['cache_array']['request_get'][$element] = $value;
	} // END - if

	// Return value
	return $value;
}

// Checks if an element in $_GET exists
function REQUEST_ISSET_GET ($element) {
	return (isset($_GET[$element]));
}

// Removes an element from $_GET
function REQUEST_UNSET_GET ($element) {
	unset($_GET[$element]);
}

// Getter for whole $_GET array
function REQUEST_GET_ARRAY () {
	return $_GET;
}

// Counts entries in $_GET or returns false if not an array
function REQUEST_GET_COUNT () {
	// By default this is not an array
	$count = false;

	// Get the array
	$GET = REQUEST_GET_ARRAY();

	// Is it an array?
	if (is_array($GET)) {
		// Then count it
		$count = count($GET);
	} // END - if

	// Return value
}

// Wrapper for elements in $_POST
function REQUEST_POST ($element) {
	// By default no element is there
	$value = null;

	// Is the element there?
	if (REQUEST_ISSET_POST($element)) {
		// Then use it
		$value = $_POST[$element];
	} // END - if

	// Return value
	return $value;
}

// Checks if an element in $_POST exists
function REQUEST_ISSET_POST ($element) {
	return (isset($_POST[$element]));
}

// Removes an element from $_POST
function REQUEST_UNSET_POST ($element) {
	unset($_POST[$element]);
}

// Getter for whole $_POST array
function REQUEST_POST_ARRAY () {
	return $_POST;
}

// Counts entries in $_POST or returns false if not an array
function REQUEST_POST_COUNT () {
	// By default this is not an array
	$count = false;

	// Get the array
	$POST = REQUEST_POST_ARRAY();

	// Is it an array?
	if (is_array($POST)) {
		// Then count it
		$count = count($POST);
	} // END - if

	// Return value
}

// Checks wether a form was sent. If so, the $_POST['ok'] element must be set
function IS_FORM_SENT () {
	// Simply wrap it!
	return REQUEST_ISSET_POST('ok');
}

//
?>
